<template>
	<div v-if="questions.length" class="d-flex flex-column align-items-center">
		<div class="align-self-end mb-4">
			{{ questionIndex + 1 }}/{{ questions.length }}
		</div>
		<div class="row w-100 d-flex align-items-center" style="height: 260px;">
			<div class="mx-auto col-12 col-sm-8 col-lg-6">
				<h5 class="question">{{ question.text }}</h5>
			</div>
		</div>
		<div class="d-flex mt-4 mb-4">
			<div class="custom-control custom-radio">
			  <input v-model="answer" value="2" type="radio" id="radio1" class="custom-control-input">
			  <label class="custom-control-label" for="radio1">Tak</label>
			</div>
			<div class="custom-control custom-radio mx-5">
			  <input v-model="answer" value="1" type="radio" id="radio2" class="custom-control-input">
			  <label class="custom-control-label" for="radio2">Częściowo</label>
			</div>
			<div class="custom-control custom-radio">
			  <input v-model="answer" value="0" type="radio" id="radio3" class="custom-control-input">
			  <label class="custom-control-label" for="radio3">Nie</label>
			</div>
		</div>
		<div class="d-flex justify-content-center w-100">
			<button @click="prew" :disabled="isFirst" type="button" class="btn btn-link bg-white">Poprzednie</button>
			<button @click="next" :disabled="isLast" type="button" class="btn btn-link bg-white">Następne</button>
		</div>
		<div class="d-flex justify-content-center w-100">
			<button @click="finish" v-if="sawLast" type="button" class="btn btn-link bg-white">Zakończ</button>
		</div>
	</div>
</template>

<script>
	import Question from 'root/clases/Question.js';
	import Answer from 'root/clases/Answer.js';

	export default {
		data() {
			return {
				questions: [],
				answers: [],
				questionIndex: 0,
				answer: null,
				sawLast: false
			}
		},

		computed: {
			question() {
				return this.questions[this.questionIndex];
			},

			isFirst() {
				return this.questionIndex === 0;
			},

			isLast() {
				return this.questionIndex === this.questions.length - 1;
			}
		},

		watch: {
			question(newQuestion) {
				this.setAnswer(newQuestion);
			},

			answer() {
				this.saveAnswer();
			},

			questionIndex(newIndex) {
				if (newIndex === this.questions.length - 1) {
					this.sawLast = true;
				}
			}
		},

		mounted() {
			this.getData();
			window.fillAll = () => this.fillAll();
		},

		methods: {
			getData() {
				Question.getQuestions()
					.then((questions) => this.questions = questions);
				this.answers = Answer.getAnswers();
			},

			prew() {
				this.isFirst ? null : this.questionIndex--;
			},

			next() {
				this.isLast ? null : this.questionIndex++;
			},

			saveAnswer() {
				Vue.set(this.answers, this.question.id, this.answer);
				Answer.saveInVuex(this.answers);
				this.$emit('answers', this.answers);
			},

			setAnswer(question) {
				this.answer = this.answers[question.id] ? this.answers[question.id] : 0;
				this.saveAnswer();
			},

			finish() {
				this.$emit('finished');
			},

			fillAll() {
				for (var i = 0; i < this.questions.length; i++) {
					Vue.set(this.answers, this.questions[i].id, _.random(0, 2));
				}
				Answer.saveInVuex(this.answers);
				this.questionIndex = 106;

				return 'That was quick!';
			}
		}
	}
</script>